;#########################################################################
;	Assembler directives

.486
.model flat,stdcall
option casemap:none

;#########################################################################
;	Include file

include DlgPreview.inc

.code

;#########################################################################
;	Common AddIn Procedures

DllEntry proc hInst:HINSTANCE, reason:DWORD, reserved1:DWORD

	mov		eax,hInst
	mov		hInstance,eax
	mov		eax,TRUE
	ret

DllEntry Endp


; Export this proc
InstallAddin proc uses ebx,hWin:DWORD

	invoke  SendMessage,hWin,AIM_GETHANDLES,0,0 ;Get pointer to handles struct
	   mov  lpHandles,eax
	invoke  SendMessage,hWin,AIM_GETPROCS,0,0   ;Get pointer to proc struct
	   mov	lpProc,eax
	invoke  SendMessage,hWin,AIM_GETDATA,0,0	;Get pointer to data struct
	   mov	lpData,eax
	invoke  SendMessage,hWin,AIM_GETMENUID,0,0  ; Allocate a new menu id
	   mov  IDAddIn,eax
	
    invoke SendMessage,hWin,AIM_DEBUGGETWIN,0,1 ;Get the Handle from Output window
       mov hOutput,eax
      mov  eax,lpHandles
	  mov  edi,[eax].ADDINHANDLES.hTbrView
	  mov hTbrView,edi
	; Messages to hook into
	   mov	AddInHook.hook1,HOOK_COMMAND or HOOK_MDIACTIVATE or HOOK_ADDINSLOADED or HOOK_MAKEDONE
	   mov	eax,offset AddInHook
	   ret
InstallAddin Endp

; Export this proc
AddinProc proc uses edi hWin:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM 
; This proc handles messages sent from RadASM to our dll
; Return TRUE to prevent RadASM and other DLL's from further processing.

    .if uMsg==AIM_MDIACTIVATE
        invoke GetWindowLong,hWin,GWL_USERDATA
           mov hEd,eax
        invoke GetWindowLong,hEd,GWL_ID
		.if eax==ID_EDITRES
            invoke  SendMessage,hTbrView,TB_CHECKBUTTON,IDM_VIEW_PROJECT,FALSE
	    .elseif eax==ID_EDITCODE
			    invoke  SendMessage,edi,TB_ISBUTTONCHECKED,IDM_VIEW_PROJECT,NULL
				.if eax ==0 ;not pressed
					invoke  SendMessage,hTbrView,TB_CHECKBUTTON,IDM_VIEW_PROJECT,TRUE
				.endif
		.endif

    .elseif uMsg==AIM_COMMAND
		mov		edx,wParam
		movzx	eax,dx
		shr		edx,16
		.if edx==BN_CLICKED && eax==IDM_VIEW_PROJECT;10047
            invoke  GetWindowLong,hEd,GWL_ID
		    .if eax==ID_EDITRES
				invoke  SendMessage,hTbrView,TB_ISBUTTONCHECKED,IDM_VIEW_PROJECT,NULL
				.if eax !=0 ;pressed
					invoke  SendMessage,hTbrView,TB_CHECKBUTTON,IDM_VIEW_PROJECT,FALSE
				    invoke  SendMessage,hEd,DEM_SHOWDIALOG,0,0
				    .if eax!=0
				        invoke	GetForegroundWindow
				          push	eax
				          call	CenterWindow
				    .endif
                  .else;not Pressed
				          mov  eax,lpHandles
				          mov  edi,[eax].ADDINHANDLES.hTool
				          mov  esi,[eax].ADDINHANDLES.hToolProject
                       invoke  SendMessage,edi,TLM_HIDE,0,esi
                         
 	            .endif
 	                  ; // The timer updates toolbar, statusbar, tab select tool and reparses a changed code file.
 	                  mov  eax,lpData
	                  mov  [eax].ADDINDATA.fTimer,1
	                  ; //
 	                  mov  eax,TRUE ;Skip in radasm original code
                      jmp  ExRet
	    	.endif
        .endif
	.endif
	
	xor eax,eax
	ExRet:
	ret
AddinProc Endp
CenterWindow proc hWin:DWORD
;---------------------------------------
    LOCAL   Wtx :DWORD
    LOCAL   Wty :DWORD
    LOCAL   Wwd :DWORD
    LOCAL   Wht :DWORD
    LOCAL   rect:RECT

    invoke  GetWindowRect, hWin, addr rect
    mov     eax, rect.right
    sub     eax, rect.left
    mov     Wwd, eax
    mov     eax, rect.bottom
    sub     eax, rect.top
    mov     Wht, eax
    invoke  GetSystemMetrics, SM_CXSCREEN
    shr     eax, 1                      ; divide screen X by 2
    mov     ebx, Wwd                    ; Get window X value
    shr     ebx, 1                      ; divide window X by 2
    sub     eax, ebx                    ; sub half win X from half screen X
    mov     Wtx, eax
    invoke  GetSystemMetrics, SM_CYSCREEN
    shr     eax, 1                      ; divide screen Y by 2
    mov     ebx, Wht                    ; Get window Y value
    shr     ebx, 1                      ; divide window Y by 2
    sub     eax, ebx                    ; sub half win Y from half screen Y
    mov     Wty, eax
    invoke  SetWindowPos, hWin, 0, Wtx, Wty, 0, 0, SWP_NOZORDER or SWP_NOSIZE
    ret
;---------------------------------------
CenterWindow endp
;;Output Window procs
;
;TextOutput proc lpszStr
;   pushad
;     push  lpszStr
;      mov  eax,lpProc
;     call  [eax].ADDINPROCS.lpTextOutput
;     push  offset szCR
;      mov  eax,lpProc
;     call  [eax].ADDINPROCS.lpTextOutput
;   popad
;   ret
;TextOutput endp
;#########################################################################

End DllEntry
